
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
  * micro applet presenting the BlowfishEasy class <b>life! on the web</b>
  * @author Markus Hahn <hahn@flix.de>
  * @version 12 Nov 98
  */

public class BlowfishDemo extends Applet {


        /**
          * applet setup
          */ 
	public void init() {
		setLayout(null);
		setSize(480,360);
		setBackground(new Color(12632256));
		passwordInfo = new Label("Password:");
		passwordInfo.setBounds(10, 10, 60, 20);
		add(passwordInfo);
		passwordBox = new TextField();
		passwordBox.setEchoChar('*');
		passwordBox.setBounds(80, 10, 390, 20);
		add(passwordBox);
		encryptBtn = new Button();
		encryptBtn.setActionCommand("button");
		encryptBtn.setLabel("Encrypt");
		encryptBtn.setBounds(290, 40, 80, 25);
		encryptBtn.setBackground(new Color(12632256));
                add(encryptBtn);
		decryptBtn = new Button();
		decryptBtn.setActionCommand("button");
		decryptBtn.setLabel("Decrypt");
		decryptBtn.setBounds(390, 40, 80, 25);
		decryptBtn.setBackground(new Color(12632256));
                add(decryptBtn);
		editor = new TextArea();
                editor.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		editor.setBounds(10, 80, 460, 265);
		editor.setText("");
		add(editor);

		WatchMouse mousingAround = new WatchMouse();
		encryptBtn.addMouseListener(mousingAround);
		decryptBtn.addMouseListener(mousingAround);
	}

        // our controls 	
	Label passwordInfo;
	TextField passwordBox;
	TextArea editor;
	Button encryptBtn;
	Button decryptBtn;


	class WatchMouse extends MouseAdapter {

	  public void mouseClicked(MouseEvent event) {
	    Object object = event.getSource();
	    if (object == encryptBtn)
  	      OnEncryptBtnClick();
	    else if (object == decryptBtn)
  	      OnDecryptBtnClick();
 	  }
	}


        // line length of an encrypted message
        private final static int ENC_MESS_LINELEN = 60;


	void OnEncryptBtnClick() {

	  // init. the cipher with the given password
	  BlowfishEasy bfeasy = new BlowfishEasy(passwordBox.getText());

          // encrypt the text
          String sCipherText = bfeasy.encryptString(editor.getText());

          // split the text into lines
          int nLen = sCipherText.length();
          StringBuffer sbuf = new StringBuffer(); 
          int nPos = 0;
          while (nPos < nLen) {
            int nEndIndex = nPos + ENC_MESS_LINELEN;
            if (nEndIndex > nLen)
              sbuf.append(sCipherText.substring(nPos, nLen));
            else
              sbuf.append(sCipherText.substring(nPos, nEndIndex) + "\n");
            nPos += ENC_MESS_LINELEN;
          };
 
          // set the whole text at once
          editor.setText(sbuf.toString());

          // clean up
          bfeasy.destroy();
	};


	void OnDecryptBtnClick() {

	  // init. the cipher with the given password
	  BlowfishEasy bfeasy = new BlowfishEasy(passwordBox.getText());

          // get the ciphertext, remove the linebreaks
          String sCipherText = editor.getText();  
          StringBuffer sbuf = new StringBuffer();
          int nLen = sCipherText.length();
          for (int nI = 0; nI < nLen; nI++) {
            char cActChar = sCipherText.charAt(nI);
            switch (cActChar) {
              case '\n' : break;
              case '\r' : break;
              default:
                sbuf.append(cActChar);
            };
          }; 
 
          // decrypt and show the original text
          String sPlainText = bfeasy.decryptString(sbuf.toString());
          if (sPlainText == null) 
            getToolkit().beep();
          else 
       	    editor.setText(sPlainText);

          // clean up
          bfeasy.destroy();
	};
};

